package tinyvm

import java.time.Instant

/**
 * Commits are a pointer to a 'head' tree with some metadata.
 */
class Commit(
    val tree: Tree,
    val author: Author,
    val message: String,
    val timestamp: Instant,
) : Object("commit") {
    override val data: String
        get() = "tree ${tree.hash()}\nauthor $author\ntimestamp ${timestamp.epochSecond}\n\n$message"

    override fun toString(): String = "commit ${hash()}\n$data"
}

data class Author(
    val name: String,
    val email: String,
) {
    override fun toString(): String = "$name <$email>"
}